#include <stdlib.h>
#include <check.h>
#include "logger.h"

pyfcgi_conf_logger_t *conf = &PyFCGI_conf.logs;

START_TEST(test_logger_init)
{

	pyfcgi_logger_init();
	ck_assert_ptr_eq(conf->syslog_ident, NULL);
	ck_assert_ptr_eq(conf->ident, NULL);
	ck_assert_ptr_eq(conf->format, NULL);
	ck_assert_ptr_eq(conf->loggers, NULL);
	ck_assert_int_eq(conf->logger_sz, 0);
	ck_assert_int_eq(conf->format_sz, 0);
	ck_assert_int_eq(conf->flags, 0);

}
END_TEST

START_TEST(test_logger_format_add)
{
	int ret;
	size_t s;
	pyfcgi_logger_init();

	ret = pyfcgi_logger_format_add("TEST", NULL);
	ck_assert_int_eq(conf->format_sz, 1);
	ck_assert_str_eq(conf->format[0], "TEST");
}
END_TEST

START_TEST(test_logger_parse_field_dtfmt_default)
{
	int ret;
	char *ptr, *orig, *fmt;

	orig = "}";
	ptr = orig;
	fmt = NULL;

printf("FUCKOFF");
	ret = pyfcgi_logger_parse_field_dtfmt((const char**)&ptr, &fmt);
	ck_assert_int_eq(ret, 0);
	ck_assert_str_eq(fmt, PYFCGI_LOGGER_TIME_FMT_DEFAULT);
}
END_TEST

Suite * logger_suite(void)
{
	Suite *s;
	TCase *tc_init, *tc_fmt, *tc_fmt_default;

	s = suite_create("Logger");

	tc_init = tcase_create("Initialisation");
	tcase_add_test(tc_init, test_logger_init);
	tcase_add_test(tc_init, test_logger_format_add);
	suite_add_tcase(s, tc_init);

	tc_fmt_default = tcase_create("Logger format default values");
	tcase_add_test(tc_fmt_default, test_logger_parse_field_dtfmt_default);
	suite_add_tcase(s, tc_fmt_default);

	//tc_fmt = tcase_create("Logger format");
	//suite_add_tcase(s, tc_fmt);

	return s;
}

int main(void)
{
	int nfailed;
	Suite *s;
	SRunner *sr;

	s = logger_suite();
	sr = srunner_create(s);
	
	//srunner_set_fork_status(sr, CK_NOFORK);
	srunner_run_all(sr, CK_NORMAL);
	nfailed = srunner_ntests_failed(sr);
	srunner_free(sr);
	return (!nfailed)?EXIT_SUCCESS:EXIT_FAILURE;
}
